package misc;

sub is_number {
    my($arg) = @_;
    return $arg =~ m/^([+-]?)(?=\d|\.\d)\d*(\.\d*)?([Ee]([+-]?\d+))?$/;
}

sub quotify {
    my($val) = @_;
    use Perl_SQL::misc;

    local $Data::Dumper::Indent = 0; # all on one line
    local $Data::Dumper::Terse = 1; # emit as an atom (must be non-self-referential

    if( !defined($val) ) { return 'undef'; }
    if( ! misc::is_number($val) ) { return Data::Dumper::Dumper($val); }
    return $val;
}

1;
