# $Header: /u/g/l/glew/cvsroot/perl-sql/lib/Perl_SQL/singleline_named_tuples.pm,v 1.1.1.1 1998/05/05 23:52:23 glew Exp $

# Deduce location of libraries distributed with package
use FindBin;
BEGIN
{
    my $install_root = $FindBin::RealBin;
    $install_root =~ s:(.*/perl-sql)/.*:$1:;
    unshift (@INC, "$install_root/lib");
}

use Perl_SQL::nice_IO;
use Perl_SQL::null_handling;
use strict;
use Perl_SQL::misc;


package singleline_named_tuples;

sub read_record
{
    my($dbfile) = @_;
    my($file) = $dbfile->{NICE_IO_FILEHANDLE};
    my($result);
    
    my($line);
    $line = $file->getline(); # TBD: make an object? Or a field of open database?

    if( !defined $line ) { return undef; }
    
    $result = eval $line;

    if( !defined $result 
       || !defined ref($result) 
       || ref($result) ne 'HASH' 
       ) {
	die "bad record evaluation: $@\n" 
	    . "expected a HASH\n" 
	    . "got <$line>\n";
    }

    return $result;
}


sub print_record 
{
    my($dbfile,$record) = @_;
    my($file) = $dbfile->{NICE_IO_FILEHANDLE};
    my($k);
    use Perl_SQL::misc;


    local $Data::Dumper::Indent = 0; # all on one line
    local $Data::Dumper::Terse = 1; # emit as an atom (must be non-self-referential

    $file->print("{ ");
    foreach $k ( sort keys(%$record) ) {
	my $val = misc::quotify($$record{$k});
        $k =~ s/'/\\'/g;		# escape quotes
        if( $k !~ m/^[A-Za-z_\$][A-Za-z_0-9\$]*$/ ) { $k = "'" . $k . "'"; }
	$file->print("\t$k => $val, "); # BUG: TBD: handling quoted strings
    } 
    $file->print("},\n");

}



"KLUGE: packages must return a true value";


