#!/s/perl-5.004/bin/perl -w

# $Header: /u/g/l/glew/cvsroot/perl-sql/lib/Perl_SQL/test:ag_perl_sql_parser.pl,v 1.1.1.1 1998/05/05 23:52:23 glew Exp $

# $Header: /u/g/l/glew/cvsroot/perl-sql/lib/Perl_SQL/test:ag_perl_sql_parser.pl,v 1.1.1.1 1998/05/05 23:52:23 glew Exp $

# Deduce location of libraries distributed with package
use FindBin;
BEGIN
{
    my $install_root = $FindBin::RealBin;
    $install_root =~ s:(.*/perl-sql)/.*:$1:;
    unshift (@INC, "$install_root/lib");
}


use Perl_SQL::ag_perl_sql_parser;		# TBD: always returns crap wrt void id string
use Perl_SQL::ag_perl_sql_lexer;
use Fstream;
use Data::Dumper;
use Perl_SQL::eval_functions;


test_driver();




######################################################
# subroutines

sub test_driver {

    my @ARGV2 = @ARGV;
    my $arg;

    while( $arg = shift @ARGV2 ) {
	if( 0 ) {
	}
	elsif( $arg eq "-verbose" ) {
	    $verbose = 1;
	}
	elsif( $arg eq "-verbose=0" ) {
	    $verbose = 0;
	}
	elsif( $arg eq "-verbose=1" ) {
	    $verbose = 1;
	}
	else {
	    die "undefined command line argument <$arg>\n";
	}

    }
    built_in_tests();
}

#############################################################################################
# built in tests




sub built_in_tests {


    my @tests = (
		 # prefix operators
		 {   
		     test_string => '+0', expect => { result => 0 },
		  },
		 {   
		     test_string => '+1', expect => { result => 1 },
		  },
		 {   
		     test_string => '+42', expect => { result => 42 },
		  },

		 {   
		     test_string => '-0', expect => { result => 0 },
		  },
		 {   
		     test_string => '!0', expect => { result => 1 },
		  },
		 {   
		     test_string => '~0', expect => { result => ~0 },
		  },
		 {   
		     test_string => 'not 0', expect => { result => 1 },
		  },

		 {   
		     test_string => '-1', expect => { result => -1 },
		  },
		 {   
		     test_string => '+(+1)', expect => { result => 1 },
		  },
		 {   
		     test_string => '-(-1)', expect => { result => 1 },
		  },
		 {   
		     test_string => '!1', expect => { result => 0 },
		  },
		 {   
		     test_string => '~1', expect => { result => ~1 },
		  },
		 {   
		     test_string => 'not 1', expect => { result => 0 },
		  },

		 {   
		     test_string => '-4', expect => { result => -4 },
		  },
		 {   
		     test_string => '+42', expect => { result => 42 },
		  },

		 # literals
		 {   
		     test_string => '0', expect => { result => 0 },
		  },
		 {   
		     test_string => '28', expect => { result => 28 },
		  },
		 {   
		     test_string => "'string'", expect => { result => 'string' },
		  },
		 {   
		     test_string => "'string' eq 'string'", expect => { result => 1 },
		  },
		 {   
		     test_string => '17+22', expect => { result => 39 },
		  },
		 {   
		     test_string => '1+2+3', expect => { result => 6 },
		  },
		 {   
		     test_string => '(1+2)+3', expect => { result => 6 },
		  },
		 {   
		     test_string => '1+(2+3)', expect => { result => 6 },
		  },
		 {   
		     test_string => '17*22', expect => { result => 374 },
		  },
		 {   
		     test_string => '1+2*3', expect => { result => 7 },
		  },
		 {   
		     test_string => '(1+2)*3', expect => { result => 9 },
		  },
		 {   
		     test_string => '1+(2*3)', expect => { result => 7 },
		  },
		 {   
		     test_string => '0&&0', expect => { result => 0 },
		  },
		 {   
		     test_string => '0&&1', expect => { result => 0 },
		  },
		 {   
		     test_string => '1&&0', expect => { result => 0 },
		  },
		 {   
		     test_string => '1&&1', expect => { result => 1 },
		  },
		 {   
		     test_string => '0||0', expect => { result => 0 },
		  },
		 {   
		     test_string => '0||1', expect => { result => 1 },
		  },
		 {   
		     test_string => '1||0', expect => { result => 1 },
		  },
		 {   
		     test_string => '1||1', expect => { result => 1 },
		  },


		 {   
		     test_string => '0 and 0', expect => { result => 0 },
		  },
		 {   
		     test_string => '0 and 1', expect => { result => 0 },
		  },
		 {   
		     test_string => '1 and 0', expect => { result => 0 },
		  },
		 {   
		     test_string => '1 and 1', expect => { result => 1 },
		  },


		 {   
		     test_string => '0 or 0', expect => { result => 0 },
		  },
		 {   
		     test_string => '0 or 1', expect => { result => 1 },
		  },
		 {   
		     test_string => '1 or 0', expect => { result => 1 },
		  },
		 {   
		     test_string => '1 or 1', expect => { result => 1 },
		  },


		 {   
		     test_string => '0 xor 0', expect => { result => 0 },
		  },
		 {   
		     test_string => '0 xor 1', expect => { result => 1 },
		  },
		 {   
		     test_string => '1 xor 0', expect => { result => 1 },
		  },
		 {   
		     test_string => '1 xor 1', expect => { result => 0 },
		  },


		 {   
		     test_string => '0 & 0', expect => { result => 0 },
		  },
		 {   
		     test_string => '0 & 1', expect => { result => 0 },
		  },
		 {   
		     test_string => '1 & 0', expect => { result => 0 },
		  },
		 {   
		     test_string => '1 & 1', expect => { result => 1 },
		  },


		 {   
		     test_string => '0 | 0', expect => { result => 0 },
		  },
		 {   
		     test_string => '0 | 1', expect => { result => 1 },
		  },
		 {   
		     test_string => '1 | 0', expect => { result => 1 },
		  },
		 {   
		     test_string => '1 | 1', expect => { result => 1 },
		  },


		 {   
		     test_string => '0^0', expect => { result => 0 },
		  },
		 {   
		     test_string => '0^1', expect => { result => 1 },
		  },
		 {   
		     test_string => '1^0', expect => { result => 1 },
		  },
		 {   
		     test_string => '1^1', expect => { result => 0 },
		  },

		 # TBD: test logicals with undefs


		 {   
		     test_string => '-42', expect => { result => -42 },
		  },
		 {   
		     test_string => '017', expect => { result => 15 },
		  },
		 {   
		     test_string => '0x0F', expect => { result => 15 },
		  },
		 {   
		     test_string => 'undef', expect => { result => undef },
		  },
		 {   
		     test_string => 'null', expect => { result => undef },
		  },
		 {   
		     test_string => 'NULL', expect => { result => undef },
		  },
		 {   
		     test_string => 'true', expect => { result =>  1 },
		  },
		 {   
		     test_string => 'false', expect => { result => 0 },
		  },
		 {   
		     test_string => 'TRUE', expect => { result => 1 },
		  },
		 {   
		     test_string => 'FALSE', expect => { result => 0 },
		  },



		 # enough constant expressions.
		 # now try testing expressions with variables, etc.

		 {   
		     test_string => 'id12', #TBD: expect => { result => undef },
		  },
		 {   
		     test_string => 'id12 + 0', #TBD: expect => { result => undef },
		  },
		 {   # bit operators - had been typoed out
		     test_string => 'A&B|C%D', #TBD: expect => { result => undef },
		  },
		 {   # xor
		     test_string => 'A^B', #TBD: expect => { result => undef },
		  },
		 {   # xor
		     test_string => 'A^B', #TBD: expect => { result => undef },
		  },
		 {   # xor
		     test_string => 'A^B', #TBD: expect => { result => undef },
		  },
		 {   # xor
		     test_string => 'A xor B', #TBD: expect => { result => undef },
		  },
		 {   
		     test_string => 'SELECT * FROM t1 WHERE t1.address IN (SELECT address FROM table1 JOIN table2 ON address)', #TBD: expect => {},
		  },
		 {   
		     test_string => '(table1 JOIN table2 ON address)', #TBD: expect => {},
		  },
		 {   # xor
		     test_string => 'SELECT a ^ b WHERE a xor b', #TBD: expect => {},
		  },
		 {   # make sure that A*B is not confused with wildcard *
		     test_string => 'A*B', #TBD: expect => { result => undef },
		  },
		 {   # debugging bugs 
		     test_string => 'SELECT sum(count)', #TBD: expect => {},
		  },
		 {   # debugging bugs 
		     test_string => 'SELECT count(*)', #TBD: expect => {},
		  },
		 # Basic SELECTs
		 {    test_string => 'select', #TBD: expect => {},
		  },
		 {    test_string => 'select "delimited id"', #TBD: expect => {},
		  },
		 {    test_string => 'select iii', #TBD: expect => {},
		  },
		 {    test_string => 'select iii+1', #TBD: expect => {},
		  },
		 {    test_string => 'select iii+1 as newname', #TBD: expect => {},
		  },
		 {    test_string => 'select iii+1 as newname, 12, kkk from tableid20', #TBD: expect => {},
		  },
		 {    test_string => 'select iii+1 as newname, 12, kkk from tableid20 where ggg > 8', #TBD: expect => {},
		  },
		 {    test_string => 'select iii+1 as newname, 12, kkk from tableid20 where ggg > 8 WHERE error', #TBD: expect => {},
		  },
		 {    test_string => 'select iii+1 as newname, 12, kkk WHERE iii > 9 from tableid20 INTO newtable', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT *', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * FROM table1 JOIN table2', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * FROM table1 OUTER JOIN table2', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * FROM table1 LEFT OUTER JOIN table2', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * FROM table1 RIGHT JOIN table2', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * FROM table1 JOIN table2 ON addr1 eq addr2', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * FROM table1 OUTER JOIN table2 ON addr1 = addr2', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * FROM table1 LEFT OUTER JOIN table2  ON addr1 = addr2', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * FROM table1 LEFT OUTER JOIN table2  ON shared_field_name', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT blah FROM table1 AS t1', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT blah FROM table1 LEFT OUTER JOIN table2 ON shared_field_name WHERE iii > 999', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT blah FROM table1 LEFT OUTER JOIN table2 ON shared_field_name WHERE t1.h > 99', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT blah FROM table1 AS t1 LEFT OUTER JOIN table2 AS t2 ON shared_field_name WHERE t1.h > 99', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT count(*)', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT count(*) FROM table1 AS t1 LEFT OUTER JOIN table2 AS t2 ON shared_field_name WHERE t1.h > 99', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT count(*) FROM (SELECT f FROM t2 WHERE t2.s > 99) WHERE jjj > 66', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT blah FROM (t3 UNION t4)', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT field FROM (t3 UNION (tableID JOIN t5 ON addr))', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT "funny id"', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT "funny id" FROM t2', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * FROM t1 JOIN t2 ON addr', #TBD: expect => {},
		  },
		 {    test_string => 'table_identifier', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * FROM (t1 UNION t2)', #TBD: expect => {},
		  },
		 
		 # Order by
		 {    test_string => 'SELECT * ORDER BY address', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * ORDER BY address ASC', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * ORDER BY address ASCENDING', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * ORDER BY address DESC', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * ORDER BY address DESCENDING', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * ORDER BY address DESCENDING, apt ASCENDING', #TBD: expect => {},
		  },

		 # SELECT DISTINCT
		 {    test_string => 'SELECT DISTINCT * ORDER BY address DESCENDING, apt ASCENDING', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT ALL * ORDER BY address DESCENDING, apt ASCENDING', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT DISTINCT', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT ALL', #TBD: expect => {},
		  },

		 # UPDATE
		 {    test_string => 'UPDATE', # AG trivial syntax
		  },
		 #{   # UPDATE table illegal - needs a SET clause in standard SQL 
		 #   test_string => 'UPDATE table', #TBD: expect => {},
		 # },
		 {    test_string => 'UPDATE tableID SET col = val, col2 = val2 WHERE col2 AND col4 < 6 ', #TBD: expect => {},
		  },
		 {    test_string => 'UPDATE FROM t1 INTO t2 SET col = val, col2 = val2 WHERE col2 AND col4 < 6 ', #TBD: expect => {},
		  },
		 {    test_string => 'UPDATE INTO t2 SET col = val, col2 = val2 WHERE col2 AND col4 < 6 FROM t2 ', #TBD: expect => {},
		  },
		 {    test_string => 'UPDATE FROM t1 SET col = val, col2 = val2 WHERE col2 AND col4 < 6 ', #TBD: expect => {},
		  },
		 {    test_string => 'UPDATE INTO t2 SET col = val, col2 = val2 WHERE col2 AND col4 < 6 ', #TBD: expect => {},
		  },

		 # Miscellaneous test cases
		 {    test_string => 'SELECT movie_title, actor_last_name, actor_first_name '
			        . ' FROM movies_stars '
				. " WHERE actor_last_name = 'Moore' AND actor_first_name = 'Demi' ", #TBD: expect => {},
		  },
		 # INSERT
		 { # null insert
		     test_string => 'INSERT', #TBD: expect => {},
		  },
		 { # values
		     test_string => 'INSERT (count,addr) VALUES (14,15)', #TBD: expect => {},
		  },
		 { # values - named fields (Glew extension syntax)
		     test_string => 'INSERT VALUES (count = 14, addr = 15)', #TBD: expect => {},
		  },
		 { # FROM, INTO
		     test_string => 'INSERT (count,addr) VALUES (14,15) FROM tableID INTO tableID', #TBD: expect => {},
		  },
		 {
		     test_string => 'INSERT INTO tableID VALUES (count = 14, addr = 15) FROM tableID', #TBD: expect => {},
		  },
		 {  # AG extension col = value; note ambiguity, reduces as a scalar expression
		     test_string => 'INSERT VALUES (count = 14, addr = 15) INTO tableID', #TBD: expect => {},
		  },
		 { # AG extension :=
		     test_string => 'INSERT VALUES (count := 14, addr := 15) INTO tableID', #TBD: expect => {},
		  },
		 { # AG extension =>
		     test_string => 'INSERT VALUES (count => 14, addr => 15) INTO tableID', #TBD: expect => {},
		  },
		 {  # AG extension col = value; note ambiguity, reduces as a scalar expression
		     test_string => 'INSERT VALUES {count = 14, addr = 15} INTO tableID', #TBD: expect => {},
		  },
		 { # AG extension :=
		     test_string => 'INSERT VALUES {count := 14, addr := 15} INTO tableID', #TBD: expect => {},
		  },
		 { # AG extension =>
		     test_string => 'INSERT VALUES {count => 14, addr => 15} INTO tableID', #TBD: expect => {},
		  },

		 # ALTER
		 {    test_string => 'ALTER TABLE catalogID.schemaID.tableID DROP COLUMN column_name', #TBD: expect => {},
		  },
		 {    test_string => 'ALTER TABLE catalogID.schemaID.tableID DROP COLUMN col1, col2', #TBD: expect => {},
		  },
		 {    test_string => 'ALTER TABLE FROM t1 DROP COLUMN col1, col2', #TBD: expect => {},
		  },
		 {    test_string => 'ALTER TABLE INTO t2 FROM t1 DROP COLUMN col1, col2', #TBD: expect => {},
		  },
		 {    test_string => 'ALTER TABLE INTO t2 DROP COLUMN col1, col2', #TBD: expect => {},
		  },
		 {    test_string => 'ALTER TABLE INTO t2 DROP COLUMN col1, col2 FROM t1', #TBD: expect => {},
		  },
		 
		 # functions
		 {    test_string => 'SELECT MAX(col1) FROM table1', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT MAX(col1,col2) FROM table1', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT COUNT(*) FROM movie_titles', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT COUNT(DISTINCT MOVIE_TITLE) FROM movies', #TBD: expect => {},
		  },

		 # correlation name
		 {    test_string => 'SELECT * FROM catalog1.myschema.movie_titles AS MT WHERE MT.OUR_COST > 11', #TBD: expect => {},
		  },

		 # CASE
		 {    test_string => '1', #TBD: expect => { result => undef },
		  },
		 {    test_string => '0', #TBD: expect => { result => undef },
		  },
		 {    test_string => 'n=0', #TBD: expect => { result => undef },
		  },
		 {    test_string => 'CASE WHEN n = 0 THEN v0 WHEN n < 0 THEN v1+1 WHEN n>5 THEN v5 ELSE jj END', #TBD: expect => {},
		  },
		 {    test_string => 'CASE switchvar WHEN 0 THEN v0 WHEN 1 THEN v1+1 ELSE jj END', #TBD: expect => {},
		  },
		 {    test_string => "UPDATE employees SET salary = CASE dept WHEN 'Video' THEN 10 WHEN 'Music' THEN 20 ELSE 0 END", #TBD: expect => {},
		  },

		 # BETWEEN
		 {    test_string => 'a BETWEEN 4 AND 5', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT female WHERE age BETWEEN 20 AND 35', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT free_time WHERE oclock NOT BETWEEN 8 AND 20', #TBD: expect => {},
		  },
		 # BUG: had forgot NOT
		 {    test_string => 'SELECT free_time WHERE NOT( time < 20 )', #TBD: expect => {},
		  },

		 # IS NULL
		 {    test_string => 'SELECT * FROM movies WHERE title IS NOT NULL', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT * FROM movies WHERE title IS NULL', #TBD: expect => {},
		  },
		 # IN
		 {   # Note: this test pattern found a bug in the Yacc grammar
		     # subquery: '(' table_expr ')' { $$ = {}; $$->{interpret_string} = deref($2); };
		     # where we were deref'ing $1 instead of $2
		     test_string => 'SELECT * FROM movies WHERE title IN (SELECT title FROM english_movies)', #TBD: expect => {},
		  },
		 # EXISTS
		 {    test_string => 'SELECT * FROM movies AS m WHERE EXISTS (SELECT m.title FROM english_movies)', #TBD: expect => {},
		  },
		 # UNIQUE
		 {    test_string => 'SELECT * FROM movies AS m WHERE UNIQUE (SELECT m.title FROM english_movies)', #TBD: expect => {},
		  },


		 ####################################################################
		 # Broken - not yet fixed
		 ####################################################################
		 
		 # Wildcards
		 { 
		     test_string => 'SELECT t.f', #TBD: expect => {},
		  },
		 { 
		     test_string => 'SELECT t.*', #TBD: expect => {},
		  },
		 {
		     test_string => 'SELECT T1.count, T2.* FROM t1 JOIN t2 ON t1.addr == t2.addr', #TBD: expect => {},
		  },

		 # Table expressions
		 {    test_string => 't1 UNION t2', #TBD: expect => {},
		  },
		 {    test_string => '(t1 JOIN t2 ON addr)', #TBD: expect => {},
		  },
		 {    test_string => 't1 JOIN t2 ON addr', #TBD: expect => {},
		  },
		 {    test_string => '"delim id" JOIN t2 ON addr', #TBD: expect => {},
		  },
		 {    test_string => 'SELECT "funny id" FROM (t3 UNION ("funny table id" JOIN t5 ON addr))', #TBD: expect => {},
		  },

		 # Row Value Constructor
		 {    test_string => 'SELECT * WHERE (c1,c2,c3) < (1,7,3)', #TBD: expect => {},
		  },
		 
		 # BUG: INSERT table_expr breaks - when grammar accepts it, it rejects some literals. Too bad.
		 { # INSERT table subexpression
		     test_string => 'INSERT INTO table (SELECT * FROM t1 WHERE foo & 1 )', #TBD: expect => {},
		  },

		 # BUG: NOT IN doesn't work
		 {    test_string => 'SELECT * FROM movies WHERE title NOT IN (SELECT title FROM english_movies)', #TBD: expect => {},
		  },

		 # function calls
		 {   
		     test_string => 'COUNT(*)', 
		  },
		 {   
		     test_string => 'avg(x)', 
		  },
		 {   
		     test_string => 'avg(x+y)', 
		  },
		 {   
		     test_string => 'MIN(x+y)', 
		  },
		 {   
		     test_string => 'max(x+y)', 
		  },
		 {   
		     test_string => 'STOP', expect => { result => "HALT" },
		  },

		 )
	;


    my $test_pattern;
    foreach $test_pattern ( @tests ) {
	#my @expect_list = @{$test_pattern->{expect}};

	my $s = IO::Scalar->new( \$$test_pattern{test_string} );
	my $lex_stream = dumb_line_re_lexer->new( pattern_table=>$ag_perl_sql_lexer::pattern_tuple_list, stream=>$s );
	my $parser = ag_perl_sql_parser->new(\&ag_perl_sql_parser::yylex, \&ag_perl_sql_parser::yyerror, 0);


	print "\nTest run ("
	    . ((exists $test_pattern->{expect}) ? 'with' : 'without') . " expected results)\n"
	    . "   input  = $test_pattern->{test_string}\n";

	my $parse_result = $parser->yyparse($lex_stream);

	# TBD: compare to expected value

	if( exists $test_pattern->{debug} && $test_pattern->{debug} ) {
	    print '   ' . Data::Dumper->Dump([$parse_result], [qw(yyparse-result)]);
	}


	if( ! $parse_result->{eval_function} ) {
	    die "undefined eval_function\n";
	}

	my $eval_result =  &eval_functions::eval_NODE($parse_result);	# TBD: how handle non-scalars?

	if( exists $test_pattern->{expect} && exists $test_pattern->{expect}->{result} ) {
	    if( $test_pattern->{expect}->{result} eq $eval_result ) {
		print "   test passed: $eval_result\n";
	    }
	    else {
		print "   test failed: expected $test_pattern->{expect}->{result}\n"
		    . "                got:     $eval_result\n";
		print '   ' . Data::Dumper->Dump([$test_pattern], [qw(test_pattern)]);
		print '   ' . Data::Dumper->Dump([$parse_result], [qw(yyparse-result)]);
		die;
	    }
	}
	else {
	    print "   output interpret_string: $parse_result->{interpret_string}\n";
	}


    }
}











